// Server.h (Test Server)

#pragma once

#using <System.Runtime.Remoting.dll>

namespace TestServer
{

using namespace System;
using namespace System::Runtime::Remoting::Channels::Tcp;
using namespace System::Threading;

public ref class Server : public MarshalByRefObject
{
public:
  Server() : m_nClientInstance(0), m_strSharedData(String::Empty)
  {}

  int GetClientInstanceNumber();
  bool IsDebugBuild();
  String ^GetSharedData();
  void SetSharedData(String ^strData);

internal:
  static Server ^GetInstance();
  static bool Startup(Action<int> ^dltStatusReportCallback);
  static void Shutdown();

private:
  static Server ^s_instance = nullptr;
  static Mutex ^s_mtxInstanceMutex = nullptr;
  static TcpClientChannel ^s_clientchannel = nullptr;
  static Action<int> ^s_dltStatusReportCallback = nullptr;

  int m_nClientInstance;
  String ^m_strSharedData;
};

public ref class Factory : public MarshalByRefObject
{
public:
  static Server ^GetServer();

  Server ^GetRemoteServer();

};

}
